#include <stdio.h>
#include <limits.h>
#include<time.h>
#include<sys/timeb.h>

// TP 3 : PAPE MACODOU SEYE, MASSAMBA SARRE, ABDOULAYE CISSE (GROUPE DE MARDI)


//INT_MAX
typedef  unsigned char UCHAR;
struct IMAGERAW
{
    int hauteur;       // la hauteur de l'image
    int largeur;      // la largeur de l'image
    UCHAR * image;
};   //taille pour stocker l'image
typedef struct IMAGERAW IMAGE;
struct _timeb start,finish;
unsigned long duration;

IMAGE*read_image()
{

    //ouverture,lecture et fermiture de fichier
    char nomfichier[80];
    IMAGE*im;
    FILE*fpI;
    int h, l;

    //Demande du nom de fichier? ouvrir le fichier en lecture et valider

    printf("Veuillez saisir le nom du fichier a ouvrir :\n");
    scanf("%s",&nomfichier);
    fpI = fopen(nomfichier, "rb");
  // printf(fpI);
    //Demandeet valider la hauteur et largeur de l'image(int h, l;)
    do
    {
        printf("Veuiller saisir la hauteur de l'image:");
        scanf("%d",&h);
    }
    while(h<0 ||h>INT_MAX);

    do
    {
        printf("Veuiller saisir la largeur de l'image:");
        scanf("%d",&l);

    }
    while(l<0 ||l>INT_MAX);

    if(fpI )
    {

        //reserver un espace memoire pour im
        im = (IMAGE*)malloc(sizeof(IMAGE));

        //initialiser les champs de im
        im->hauteur = h;
        im->largeur = l;

        im->image = (UCHAR)malloc(im->hauteur*im->largeur);

        //Lire l'image sur le disque
        fread(im->image,sizeof(UCHAR),im->hauteur*im->largeur,fpI);
        fclose(fpI);
        return (im) ;
    }

}

IMAGE*crypter_decrypter(IMAGE*im)
{
    int L, H, m,n,choix ;
    UCHAR key;
    L = im->largeur;   //largeur de l'image
    H = im->hauteur;   //hauteur de l'image

    do
    {
        printf("veuiller saisir la valeur de la cle :\n");
        scanf("%d", &key);
    }
    while(key<=0&&key>=255);

    printf("veuiller choisir l'ordre de parcours de la matrice 0 pour rangee ou 1 pour colonne :\n");
    scanf("%d", &choix);

    _ftime(&start);
    switch(choix)
    {
    case 0:

        for(m=0; m<H; m++)     // Accs sans positionnement spatiale
        {
            for(n=0; n<L; n++)  // Parcours par colonne
            {
                im->image[m*L+n] = im->image[m*L+n]^key;
                printf("yes");
            }
        }
        break;

    case 1:
        for(n=0; n<L; n++)    //Accs avec positionnement
        {
            for(m=0; m<H; m++)  // Parcours par colonne
            {
                im->image[m*H+n] = im->image[m*H+n]^key;
            }

        }
        break;

    default:
        printf("choisisser entre 0 et 1");
    }
    _ftime(&finish);
    duration = ((unsigned long)finish.time*1000L +(unsigned long)finish.millitm) -((unsigned long)start.time*1000L + (unsigned long)start.millitm);
    printf("Le temps d'excution : %d ms \n",duration);
}
void write_image(IMAGE*imageD)
{
    //Overture,ecriture et fermeture du fichier

    char nomfichier [80];
    FILE *fpD;

    do
    {
        printf("Veuillez saisir le nom de l'image obtenu :\n");
        scanf("%s", &nomfichier);
        fpD =fopen(nomfichier,"wb");
    }
    while(fpD == NULL);

    fwrite(imageD->image, sizeof(UCHAR), imageD->hauteur*imageD->largeur,fpD);

    fclose(fpD);
}

main()
{
    //Declaration d'un pointeur sur une structure Image
    IMAGE *im;

    //Lecture de l'image  crypter

    im = read_image();
    //cryptage de l'image

    crypter_decrypter(im);

    //Sauvegarde de l'image cryptee

    write_image(im);

    //Liberation de la RAM attribue Dynamiquement
    free(im->image);
    free(im);
}














