//UNIVERSITE DU QUEBEC A TROIS RIVIERES

//   Travail Pratique Architecture des ordinateurs SIF1053

/* AUTEURS: 
Malick DIEYE:DIEM4020000
Adja Aissatou SARR:SARA7030400
Mame diarra SYLLA:SYLM14599800*/



#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#define MAX 1000
	typedef unsigned char UCHAR;
struct IMAGERAW
{
    int hauteur; //hauteur de image
    int largeur;  //largeur de image
    UCHAR*image;
};
typedef struct IMAGERAW IMAGE ;
struct _timeb start,finish;
unsigned long duration;
IMAGE*lire_image() //ouverture,lecture et fermeture du fichier
{
char nomfichier[80];
IMAGE*im;
FILE*fpI;
int l,h;

//ouverture du fichier
printf("entrer le nom du fichier:\n");
scanf("%s",&nomfichier);
fpI =fopen(nomfichier,"rb");
do
{
   printf("donner la hauteur de l'image:\n");
   scanf("%d",&h);
} while (h<0 || h>INT_MAX);
do
{
    printf("donner la largeur de l'image:\n");
     scanf("%d",&l); 
} while (l<0 || l>INT_MAX);

if (fpI)
{
    /* reserver un espace memoire pour l'image */
    im = (IMAGE*)malloc(sizeof(IMAGE));
    im->hauteur = h;
    im->largeur = l;
    im->image = (UCHAR)malloc(im->hauteur*im->largeur);
    //la lecture de l'image
    fread(im->image,sizeof(UCHAR),im->hauteur*im->largeur,fpI);
    fclose(fpI);
    return im;
}
}
IMAGE*crypter_decrypter(IMAGE*im)
{
int L,H,m,n,choix;
UCHAR cle;
H=im->hauteur;   //l'hauteur image
L=im->largeur;    //largeur image
do
{
    printf("saisissez la valeur de la cle:\n");
    scanf("%d",&cle);
} while (cle<=0 && cle>=8);

printf("choisissez l'odre de parcours de la matrice :0 pour la range et 1 pour la colonne\n");
scanf("%d",&choix);

ftime(&start);
switch (choix)
{
case 0:
    for (m=0; m < H; m++)
    {
       for (n=0; n < L; n++) //le parcour par colonne
       {
        im->image[m*L+n] = im->image[m*L+n]^cle;
        printf("oui");
       }
       
    }
    
    break;
case 1:
     for (n=0; n < L; n++)
     {
        for (m=0; m < H; m++)
        {
            im->image[m*H+n] = im->image[m*H+n]^cle;
        }
        
     }
     break;
default:
   printf("choisir 1 ou 0\n") ;
}
ftime(&finish);
duration = ((unsigned long)finish.time*1000L + (unsigned long)finish.millitm) - (unsigned long)start.time*1000L + (unsigned long)start.millitm;
printf("temps d'execution:%d ms\n",duration);
}
void ecrire_image(IMAGE*imageD)
{
    char nomfichier[80];
    FILE*fpD;
    do
    {
       printf("saisissez le nom de l'image :\n ");
       scanf("%s",&nomfichier);
       fpD = fopen(nomfichier,"wb");
    } while (fpD == NULL);
    fwrite(imageD->image,sizeof(UCHAR),imageD->hauteur*imageD->largeur,fpD);
    fclose(fpD);
}
int main(int argc, char const *argv[])
{
    //pointeur sur une structure image
    IMAGE*im;
    //lecture de l'image
    im = lire_image;
    //cryptage de l'image
    crypter_decrypter(im);
    //sauvegarde de l'image
    ecrire_image(im);

    free(im->image);
    free(im);
    
}





















