//Programme réalisé par : Olivier Harrisson - SIF1053 - Université du Québec à Trois-Rivières UQTR

#include <stdlib.h>
#include <stdlib.h>

typedef unsigned char UCHAR;

struct IMAGERAW {
    int hauteur;
    int largeur;
    UCHAR *image;
};

typedef struct IMAGERAW;

IMAGE* lire_image(const char *nom_fichier) {
    // Code pour ouvrir et lire le fichier .raw
    // Lire les dimensions et les octets de l'image
    // Allouer de la mémoire pour l'image et la stocker dans une structure IMAGE
    // Retourner l'image lue
}

IMAGE* crypter_decrypter(IMAGE *imageS, int choix) {
    IMAGE *imageD = (IMAGE *)malloc(sizeof(IMAGE));
    imageD->hauteur = imageS->hauteur;
    imageD->largeur = imageS->largeur;
    imageD->image = (UCHAR *)malloc(imageS->hauteur * imageS->largeur * sizeof(UCHAR));

    UCHAR cle = 0xAA; // Clé de 8 bits pour le XOR (exemple)

    // Cryptage ou décryptage ici, en utilisant le XOR avec la clé
    for (int i = 0; i < imageS->hauteur * imageS->largeur; i++) {
        imageD->image[i] = imageS->image[i] ^ cle; // XOR avec la clé
    }

    return imageD;
}

void ecrire_image(IMAGE *imageD, const char *nom_fichier) {
    // Code pour écrire l'image cryptée ou décryptée dans un fichier .raw
    // Assurez-vous de libérer la mémoire appropriée une fois l'écriture terminée
}

int main() {
    IMAGE *imageSource = lire_image("nom_de_votre_image.raw");
    // Effectuer le cryptage ou le décryptage (selon l'entrée de l'utilisateur)
    int choix = 0; // Vous devez obtenir ce choix de l'utilisateur
    IMAGE *imageDestination = crypter_decrypter(imageSource, choix);
    ecrire_image(imageDestination, "image_cryptee_decryptee.raw");

    // Libérer la mémoire
    free(imageSource->image);
    free(imageSource);
    free(imageDestination->image);
    free(imageDestination);

    return 0;
}
