#include "tp3.h"
#include <stdio.h>
#include <stdlib.h>

/**
 * @brief Fonction principale du programme.
 * 
 * @return 0 si le programme s'est exécuté avec succès.
 */
int main() {
    IMAGE *im;

    // Lecture de l'image à crypter
    im = lire_image();

    // Cryptage/Décryptage de l'image
    crypter_decrypter(im);

    // Sauvegarde de l'image cryptée
    ecrire_image(im);

    // Libération de la mémoire
    free(im->image);
    free(im);

    return 0;
}
