/** *************************CHEIKH DIAKHATE
 ***********************DAOUR TOP
******************** CHEIKH TIDIANE DIAKHATE
**************** KHADY LOUM

 */
 #include "tp3.h"
#include <stdio.h>
#include <stdlib.h>

IMAGE *lire_image() {
    char nomfichier[80];
    IMAGE *im;
    FILE *fpI;
    int h, l;

    printf("Veuillez saisir le nom du fichier a ouvrir :\n");
    scanf("%s", nomfichier);

    if ((fpI = fopen(nomfichier, "rb")) == NULL) {
        printf("Erreur lors de l'ouverture du fichier.\n");
        exit(1);
    }

    do {
        printf("Veuiller saisir la hauteur de l'image:");
        scanf("%d", &h);
    } while (h < 0 || h > INT_MAX);

    do {
        printf("Veuiller saisir la largeur de l'image:");
        scanf("%d", &l);
    } while (l < 0 || l > INT_MAX);

    im = (IMAGE *)malloc(sizeof(IMAGE));
    im->hauteur = h;
    im->largeur = l;
    im->image = (UCHAR *)malloc(im->hauteur * im->largeur);
    fread(im->image, sizeof(UCHAR), im->hauteur * im->largeur, fpI);
    fclose(fpI);
    return im;
}

IMAGE *crypter_decrypter(IMAGE *im) {
    int L, H, m, n, choix;
    UCHAR cle;

    L = im->largeur;
    H = im->hauteur;

    do {
        printf("veuiller saisir la valeur de la cle :\n");
        scanf("%hhu", &cle);
    } while (cle <= 0 && cle >= 255);

    printf("veuiller choisir l'ordre de parcours de la matrice 0 pour rangee ou 1 pour colonne :\n");
    scanf("%d", &choix);

    for (m = 0; m < H; m++) {
        for (n = 0; n < L; n++) {
            switch (choix) {
                case 0:
                    im->image[m * L + n] = im->image[m * L + n] ^ cle;
                    break;
                case 1:
                    im->image[m * H + n] = im->image[m * H + n] ^ cle;
                    break;
                default:
                    printf("Choisissez entre 0 et 1.\n");
            }
        }
    }

    return im;
}

void ecrire_image(IMAGE *imageD) {
    char nomfichier[80];
    FILE *fpD;

    do {
        printf("Veuillez saisir le nom de l'image obtenue :\n");
        scanf("%s", nomfichier);
        fpD = fopen(nomfichier, "wb");
    } while (fpD == NULL);

    fwrite(imageD->image, sizeof(UCHAR), imageD->hauteur * imageD->largeur, fpD);
    fclose(fpD);
}
