

/* Cheikh Khouma / KHOC74270200 */
/* Mouhamed Ndiaga Sene / SENM78010300 */


#include <stdio.h>
#include <stdlib.h>
#include <time.h>



typedef unsigned char UCHAR;

//Structure pour representer une image
struct IMAGERAW{
int hauteur;
int largeur;
UCHAR *image;
};
typedef struct IMAGERAW IMAGE;

//Fonction pour la lecture de l'image a partirt du  fichier
IMAGE lire_image(const char*nom_fichier){
FILE *fichier=fopen(nom_fichier,"rb");

IMAGE image;
fread(&image.hauteur,sizeof(int),1,fichier);
fread(&image.largeur,sizeof(int),1,fichier);
image.image=(UCHAR *)malloc(image.hauteur * image.largeur *sizeof(UCHAR));
fread(image.image,sizeof(UCHAR),image.hauteur*image.largeur,fichier);

fclose(fichier);
return image;
}
//fonction pour crypter ou decrypter
IMAGE *crypter_decrypter(IMAGE *image,int indice){
    IMAGE *imageD=(IMAGE*)malloc (sizeof(IMAGE));
    imageD->hauteur=imageD->hauteur;
    imageD->largeur=imageD->largeur;
    imageD->image=(UCHAR*)malloc(image->hauteur * image->largeur * sizeof(UCHAR));


UCHAR cle=0b11011011;
//star time
clock_t start_time=clock();
int i;
for( i=0;i<image->hauteur*image->largeur;i++){
    int position;
    int choice;
    if(choice==1){
        //cryptage par rangee
        position=i%image->largeur+(i/image->largeur)*image->largeur;
    }else{
        //cryptage par colonne
        position=i%image->largeur* image->hauteur + i/ image->largeur;
    } imageD->image[position]=image->image[i]^cle;
}

//end time
clock_t end_time=clock();

//clacul et affichage du temps d'Execution
double execution_time=((double)(end_time - start_time)) / CLOCKS_PER_SEC;
printf("Execution time : %f seconds\n",execution_time);
 return imageD;
}

//Fonction pour ecrire image dans le fichier
void ecrire_image(IMAGE*image,const char *nom_fichier){
FILE *fichier=fopen(nom_fichier,"wb");
fwrite(&image->hauteur,sizeof(int),1,fichier);
fwrite(&image->largeur,sizeof(int),1,fichier);
fwrite(image->image,sizeof(UCHAR),image->hauteur*image->largeur,fichier);

fclose(fichier);
}

//fonction principale main()

main(){
    const char *nomFichier="benji.raw";

//lire image a partir du fichier
IMAGE imageS=lire_image(nomFichier);

//Effectuer le cryptage/decryptage
    //demander l'utilisateur s'il veut effectuer le calcul par rangee ou colonne;
    int indice;
printf("Cryptage/Decryptage 1 par rangee,2 par colonne?");
scanf("%d",&indice);
IMAGE*image_crypter=crypter_decrypter(&imageS,indice);

//ECRIRE l' encryption/decryption image dans le fichier
ecrire_image("benji.raw",image_crypter);

//liberer la memoire si necessaire
free(imageS.image);
free(image_crypter->image);
free(image_crypter);

}





