
#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>
#include <malloc.h>

// creation de la structure image raw
typedef unsigned char UCHAR
struct IMAGERAW{
    int hauteur;
    int largeur;
    UCHAR*image;
}
typedef struct IMAGERAW IMAGE;

//declaration de variables utiles
// variables imageD et imageS de type IMAGE
IMAGE*imageD, *imageS;


//fonction lire image
//fonction qui demande a l'utilisateur le nom de l'image á lire sur disque, sa hauteur
//et sa largeur, puis on fait la lecture de cette image

IMAGE*lire_image()
{   
    char nom_du_fichier[80];
    IMAGE*imageS;              // pointeur de type IMAGE
    FILE*benji.raw;       // pointeur sur une structure FILE qui contient les informations du fichier image en lecture 
    int hauteur,largeur;
   
  printf("veillez entrer le nom du fichier qui contiendra la photo: \n");
  scanf("%s", &nom_du_fichier);
  benji.raw=fopen(&nom_du_fichier, "rb");
                    
      if (fpl !=NUL)          //validation du nom du fichier
      printf("nom du fichier correct \n");
      else 
      printf("nom du fichier correct, veillez entrer le nom d'un fichier existant:\n");
    

  printf("veillez entrer la hauteur du fichier: \n");
  scanf("%d", &hauteur);

  printf("veillez entrer la largeur du fichier: \n");
  scanf("%d", &largeur);
  imageS = (IMAGE*)malloc(sizeof(IMAGE));
  imageS->largeur= largeur;
  imageS->hauteur= hauteur;
  imageS->image = (UCHAR*) malloc(imageS->hauteur*imageS->largeur);

  fread(imageS->image,sizeof(UCHAR),imageS->hauteur*imageS->largeur,benji.raw);
  
  fclose(benji.raw);
  return (imageS);     //retourne la reference sur le stricture imageraw initialisé par lire_image
 
}  


//fonction crypter_decrypter
//fonction qui demande á l'utilisateur la valeur de la clé de codification / l'ordre de traitement
// des pixels de l'image, puis on parcourt l'ensemble des pixels en fonction de l'ordre de traitement
//en y appliquant un chronometre qui reseigne sur le temps de traitement.

IMAGE*crypter_decrypter(IMAGE imageS)
{ 
  struct_timeb start, finish;
  unsigned long duration;
  UCHAR key ;
  int m,n,H,L;
  IMAGE*imageS;
  imageS= (IMAGE*)malloc(sizeof(IMAGE));
  L = imageS->largeur;
  H = imageS->hauteur;
  imageS->image = (UCHAR*)malloc(imageS>hauteur*imageS->largeur);
  
  printf("veillez entrer la valeur de la clé a utiliser entre 0 et 255: \n");
  scanf("%c", &key);
  if (key >= 0 && key <=255)// validation de la valeur de la clé
  {
    printf("la valeur de la clé á utiliser est correcte \n");
  }
  else {
    printf("la valeur de la clé á utiliser est incorrecte \n" + " la clé doit etre comprise entre 0 et 255\n" + "entrez une nouvelle valeur de la clé");
  }
  // choisir le type parcours de la matrice, soit par rangée, soit par colonne
  int order;    
    printf ("entrez l'ordre de parcours de la matrisse image (1 ou 2)\n");
    printf ("1-parcours par rangés \n");
    printf ("2-parcours par colonnes \n");
    scanf("%d", &order);
    
     
    switch(order)
    {
     case 1 :     
      ftime(&start);                //debut du chronometre, parcours par rangés
        for(m=0;m<H;m++)   
        for(n=0;n<H;n++)
         imageS->image[m*L+n] = imageS->image[m*L+n]^key; 
      ftime(&finish)                //fin du chronometre 

       //calcul et affichage du temps ecoulé du debut á la fin du parcours par rangé de la matrice
       duration = ((unsigned long)finish.time*1000L + (unsigned long)finish.millitm) 
        - ((unsigned long)start.time*1000L + (unsigned long)start.millitm);
        printf("Temps d'execution (par rangé): %d ms\n", duration);   
      
     break;
      
     case 2:
      ftime(&start);                //debut du chronometre  , parcours par colonnes
       for(n=0;n<H;n++)   
       for(m=0;m<H;m++)
         imageS->image[m*L+n] =imageS->image[m*L+n]^key; 
      ftime(&finish)               //fin du chronometre 

      //calcul et affichage du temps ecoulé du debut á la fin du parcours par colonnes de la matrice
      duration = ((unsigned long)finish.time*1000L + (unsigned long)finish.millitm) 
        - ((unsigned long)start.time*1000L + (unsigned long)start.millitm);
       printf("Temps d'execution (par colonne) : %d ms\n", duration);  
     break;

    }
}
  
//fonction ecrire_image
//fonction qui sauvegarde l'image resultante aprés codification sur disque

void ecrire_image(IMAGE imageD)
{
  char nomfichier[80];
  FILE*benjicod.raw;
  benjicod.raw = (FILE*)malloc(sizeof(FILE));

  printf("veillez entrer le nom du fichier contenant l'image codé á ecrire sur le disque: \n");
  scanf("%s", &nomfichier);
    fpD = fopen(&nomfichier, "wb");
    fwrite(imageD->image,sizeof(UCHAR),imageD->hauteur*imageD->largeur,fpD);

    // valeur valide
    fclose(fpD);
}
        